javax.resource.spi.security

## Interface GenericCredential

- Deprecated.
  The preferred way to represent generic credential information is via the `org.ietf.jgss.GSSCredential` interface in J2SE Version 1.4, which provides similar functionality.

      public interface GenericCredential

  The interface `javax.resource.spi.security.GenericCredential` defines a security mechanism independent interface for accessing security credential of a resource principal.

  The `GenericCredential` interface provides a Java wrapper over an underlying mechanism specific representation of a security credential. For example, the `GenericCredential` interface can be used to wrap Kerberos credentials.

  The connector architecture does not define any standard format and requirements for security mechanism specific credentials. For example, a security credential wrapped by a GenericCredential interface can have a native representation specific to an operating system.

  The GenericCredential interface enables a resource adapter to extract information about a security credential. The resource adapter can then manage EIS sign-on for a resource principal by either:

  - using the credentials in an EIS specific manner if the underlying EIS supports the security mechanism type represented by the GenericCredential instance, or,
  - using GSS-API if the resource adapter and underlying EIS instance support GSS-API.
  Since:
    0.7
  Version:
    0.7
  Author:
    Rahul Sharma
  See Also:
    `Subject`, `Principal`

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(java.lang.Object another)` Deprecated. Tests if this GenericCredential instance refers to the same entity as the supplied object.
    `byte[]` | `getCredentialData()` Deprecated. Gets security data for a specific security mechanism represented by the GenericCredential.
    `java.lang.String` | `getMechType()` Deprecated. Returns the mechanism type for the GenericCredential instance.
    `java.lang.String` | `getName()` Deprecated. Returns the name of the resource principal associated with a GenericCredential instance.
    `int` | `hashCode()` Deprecated. Returns the hash code for this GenericCredential

- - ### Method Detail

    - #### getName

          java.lang.String getName()

      Deprecated.
      Returns the name of the resource principal associated with a GenericCredential instance.
      Returns:
        Name of the principal

    - #### getMechType

          java.lang.String getMechType()

      Deprecated.
      Returns the mechanism type for the GenericCredential instance. The mechanism type definition for GenericCredential should be consistent with the Object Identifier (OID) based representation specified in the GSS specification. In the GenericCredential interface, the mechanism type is returned as a stringified representation of the OID specification.
      Returns:
        mechanism type

    - #### getCredentialData

          byte[] getCredentialData()
                            throws SecurityException

      Deprecated.
      Gets security data for a specific security mechanism represented by the GenericCredential. An example is authentication data required for establishing a secure association with an EIS instance on behalf of the associated resource principal.

      The getCredentialData method returns the credential representation as an array of bytes. Note that the connector architecture does not define any standard format for the returned credential data.

      Returns:
        credential representation as an array of bytes.
      Throws:
        `SecurityException` - Failed operation due to security related error condition

    - #### equals

          boolean equals(java.lang.Object another)

      Deprecated.
      Tests if this GenericCredential instance refers to the same entity as the supplied object. The two credentials must be acquired over the same mechanisms and must refer to the same principal. Returns true if the two GenericCredentials refer to the same entity; false otherwise.
      Overrides:
        `equals` in class `java.lang.Object`
      Parameters:
        `another` - The other object
      Returns:
        True if equal; otherwise false

    - #### hashCode

          int hashCode()

      Deprecated.
      Returns the hash code for this GenericCredential
      Overrides:
        `hashCode` in class `java.lang.Object`
      Returns:
        hash code for this GenericCredential

Copyright © 2014 IronJacamar (http://www.ironjacamar.org)